{*file puq_customization/extensions/ExportTool/templates/config_group.tpl*}

<style>
    #visualTableContainer table {
        width: 100%;
        border-collapse: collapse;
    }
    .clickable-table-name {
        cursor: pointer;
    }

    @keyframes fadeIn {
        from { opacity: 0.5; }
        to { opacity: 1; }
    }
    .tab-pane * {
        animation: fadeIn 0.3s ease-in-out forwards;
    }

</style>


<form method="post" action="{$before_path}/admin/addonmodules.php?module=puq_customization&extension=export_tool&action=config_group&group={$get['group']}" onsubmit="return validateIP()">

    <div class="tab-pane">
        <table class="form" width="100%" border="0" cellspacing="2" cellpadding="3">
            <tbody>


            <!-- Group name -->
            <tr>
                <td class="fieldlabel">{$lang['Group name']}</td>
                <td class="fieldarea">
                    <input type="text" class="form-control select-inline" name="group_name" value="{$get['group']}" size="25">
                </td>
            </tr>


            <!-- Security Settings -->
            <tr>
                <td class="fieldlabel">{$lang['Secret Word']}</td>
                <td class="fieldarea">
                    <input type="text" class="form-control select-inline" name="secret_word" value="" size="25" oninput="updateSecretWord()">
                </td>
            </tr>

            <!-- Security IP address -->
            <tr>
                <td class="fieldlabel">{$lang['Access IP']}</td>
                <td class="fieldarea">
                    <input type="text" class="form-control select-inline" name="access_ip" value="" size="25" oninput="updateIP()">
                </td>
            </tr>

            <!-- Tables for Export -->
            <tr>
                <td class="fieldlabel">{$lang['Tables for Export']}</td>
                <td class="fieldarea">
                    <select name="selected_table" class="form-control select-inline" onchange="updateTableAttributes(this)">
                        {foreach from=$showTables item=table}
                            <option value="{$table}">{$table}</option>
                        {/foreach}
                    </select>
                    <input type="hidden" name="available_tables" value='{$available_tables}'>
                    <div id="attributesContainer">
                        <!-- checkbox attributes -->
                    </div>
                </td>
            </tr>
            <!-- Where for Export -->
            <tr>
                <td class="fieldlabel">{$lang['Where condition']}</td>
                <td class="fieldarea">
                    <div id="whereContainer">
                        <!-- Attribute from Tables for Export -->
                    </div>
                </td>
            </tr>


            <!-- Visual Tables for Export -->
            <tr>
                <td class="fieldlabel">{$lang['Visual Tables for Export']}</td>
                <td class="fieldarea">
                    <div id="visualTableContainer" class="dataTables_wrapper form-inline dt-bootstrap no-footer"></div>
                </td>
            </tr>

            </tbody>
        </table>
    </div>
    <!-- Submit Button -->
    <div class="btn-container">
        <button type="submit" name="submit" value="submit" class="btn btn-primary">{$lang['Save Changes']}</button>
        <input type="button" class="btn btn-warning" value="{$lang['Return']}" onclick="redirectToPage('{$before_path}/admin/addonmodules.php?module=puq_customization&extension=export_tool&action=config_tables')">
    </div>
</form>

<script type="text/javascript">
    var tableAttributes = {$tableAttributes|json_encode};
    var selectedAttributes = {$available_tables};
    var available_tables = {};
    var currentTable = '';
    var whereConditions = {};

    if (selectedAttributes["{$get['group']}"] && selectedAttributes["{$get['group']}"]['where_conditions']) {
        if (typeof selectedAttributes["{$get['group']}"]['where_conditions'] === 'object' && !Array.isArray(selectedAttributes["{$get['group']}"]['where_conditions'])) {
            whereConditions = selectedAttributes["{$get['group']}"]['where_conditions'];
        } else {
            whereConditions = {};
            selectedAttributes["{$get['group']}"]['where_conditions'].forEach(function(condition) {
                if (condition && typeof condition === 'object') {
                    Object.keys(condition).forEach(function(key) {
                        whereConditions[key] = condition[key];
                    });
                }
            });
        }
    } else {
        whereConditions = {};
    }


    function redirectToPage(URL) {
        window.location.href = URL;
    }

    function updateSecretWord() {
        var secretWordValue = document.querySelector('input[name="secret_word"]').value;
        var groupName = document.querySelector('input[name="group_name"]').value;

        var savedData = JSON.parse(document.querySelector('input[name="available_tables"]').value || '{}');
        if (savedData[groupName]) {
            savedData[groupName]["secret_word"] = secretWordValue;
            document.querySelector('input[name="available_tables"]').value = JSON.stringify(savedData);
        }
    }

    function saveWhereCondition(tableName, attributeName, value) {
        if (!whereConditions[tableName]) {
            whereConditions[tableName] = {};
        }
        if (value.trim() !== '') {
            whereConditions[tableName][attributeName] = value;
        } else {
            delete whereConditions[tableName][attributeName];
            if (Object.keys(whereConditions[tableName]).length === 0) {
                delete whereConditions[tableName];
            }
        }
        updateHiddenField();
    }


    function validateIP() {
        var ipInput = document.querySelector('input[name="access_ip"]');
        var ipValue = ipInput.value.split(',').map(ip => ip.trim());

        var ipRegex = /^(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)$/;

        var allValid = ipValue.every(ip => ipRegex.test(ip));

        if (!allValid) {
            alert("{$lang['One or more IP addresses are invalid. Please check your input.']}");
            return false;
        }

        return true;
    }


    function updateIP() {
        var ipValue = document.querySelector('input[name="access_ip"]').value.split(',').map(ip => ip.trim());
        var groupName = document.querySelector('input[name="group_name"]').value;

        var savedData = JSON.parse(document.querySelector('input[name="available_tables"]').value || '{}');
        if (savedData[groupName]) {
            savedData[groupName]["access_ip"] = ipValue;
            document.querySelector('input[name="available_tables"]').value = JSON.stringify(savedData);
        }
    }

    function updateWhereSection() {
        var whereContainer = document.getElementById('whereContainer');
        whereContainer.innerHTML = '';

        var selectedAttributesForCurrentTable = selectedAttributes[currentTable] || [];

        selectedAttributesForCurrentTable.forEach(function(attribute) {
            var inputId = 'where_' + currentTable + '_' + attribute;
            var inputValue = whereConditions[currentTable] && whereConditions[currentTable][attribute] ? whereConditions[currentTable][attribute] : '';

            var div = document.createElement('div');
            div.innerHTML = '<label for="' + inputId + '">' + attribute + ': </label>' +
                '<input type="text" id="' + inputId + '" name="where[' + currentTable + '][' + attribute + ']" value="' + inputValue + '" class="form-control" oninput="updateWhereAndHiddenField(\'' + currentTable + '\', \'' + attribute + '\', this.value)">';
            whereContainer.appendChild(div);
        });
    }

    function updateWhereAndHiddenField(tableName, attributeName, value) {
        saveWhereCondition(tableName, attributeName, value);
        saveCurrentSelection(tableName)
        updateHiddenField();
    }




    function updateTableAttributes(selectElement) {


        currentTable = selectElement.value;
        var attributes = tableAttributes[currentTable] || [];
        var attributesHtml = '<table class="datatable table table-themed display data-driven filterable dataTable no-footer" cellspacing="1" cellpadding="3" border="0">';
        attributesHtml += '<tr><th width="20"><input type="checkbox" id="checkAllAttributes" onclick="checkAllChanged(this)" value="skip_checked_778jj66"></th><th>Attributes</th></tr>';

        attributes.forEach(function(attribute) {
            var checked = selectedAttributes[currentTable] && selectedAttributes[currentTable].includes(attribute) ? ' checked' : '';
            attributesHtml += '<tr>';
            attributesHtml += '<td width="20" class="text-center" onclick="checkAttributeChanged(\'' + attribute + 'checkbox\')"><input id="' + attribute + 'checkbox" onclick="checkAttributeChanged(\'' + attribute + 'checkbox\')" class="checkAllAttributesCheck" type="checkbox" name="attributes[' + currentTable + '][]" value="' + attribute + '"' + checked + ' onchange="updateSelectedAttributes()"></td>';
            attributesHtml += '<td id="' + attribute + 'td" onclick="checkAttributeChanged(\'' + attribute + 'checkbox\')"><label>' + attribute + '</label></td>';
            attributesHtml += '</tr>';
        });
        attributesHtml += '</table>';
        document.getElementById('attributesContainer').innerHTML = attributesHtml;
        updateWhereSection();
    }

    function updateWhereSection() {
        var whereContainer = document.getElementById('whereContainer');
        whereContainer.innerHTML = '';

        var selectedAttributesForCurrentTable = selectedAttributes[currentTable] || [];

        selectedAttributesForCurrentTable.forEach(function(attribute) {
            var inputId = 'where_' + currentTable + '_' + attribute;
            var inputValue = whereConditions[currentTable] && whereConditions[currentTable][attribute] ? whereConditions[currentTable][attribute] : '';

            var div = document.createElement('div');
            var input = document.createElement('input');
            input.type = 'text';
            input.id = inputId;
            input.name = 'where[' + currentTable + '][' + attribute + ']';
            input.value = inputValue;
            input.className = 'form-control';
            input.oninput = function() {
                updateWhereAndHiddenField(currentTable, attribute, this.value);
                updateVisualTable(selectedAttributes)
            };

            var label = document.createElement('label');
            label.htmlFor = inputId;
            label.textContent = attribute + ': ';

            div.appendChild(label);
            div.appendChild(input);
            whereContainer.appendChild(div);
        });
    }

    function saveCurrentSelection(table) {
        var checkboxes = document.querySelectorAll('#attributesContainer input[type="checkbox"]');
        selectedAttributes[table] = [];

        checkboxes.forEach(function(checkbox) {
            if (checkbox.checked && checkbox.value !== "skip_checked_778jj66") {
                selectedAttributes[table].push(checkbox.value);
            }
        });

        if (selectedAttributes[table].length === 0) {
            delete selectedAttributes[table];
            delete whereConditions[table];
        }

        updateHiddenField();
    }



    function updateSelectedAttributes() {
        saveCurrentSelection(currentTable);
        updateHiddenField();
        updateVisualTable(selectedAttributes);
        updateWhereSection();
        updateIP();
        updateSecretWord();
    }

    function updateHiddenField() {
        var groupName = document.querySelector('input[name="group_name"]').value.trim();
        var savedData = JSON.parse(document.querySelector('input[name="available_tables"]').value || '{}');
        if (!savedData[groupName]) {
            savedData[groupName] = { access_ip: [], access_table: {}, where_conditions: {} };
        }
        savedData[groupName].access_ip = document.querySelector('input[name="access_ip"]').value.split(',').map(ip => ip.trim());
        savedData[groupName].access_table = selectedAttributes;
        if (Object.keys(whereConditions).length > 0) {
            savedData[groupName].where_conditions = whereConditions;
        } else {
            savedData[groupName].where_conditions = {};
        }
        document.querySelector('input[name="available_tables"]').value = JSON.stringify(savedData);
    }






    function updateVisualTable(accessTable) {
        var container = document.getElementById('visualTableContainer');
        var tablesNameMd5 = {$tables_name_md5|json_encode} ?? {};
        var html = '<table class="datatable table table-themed display data-driven filterable dataTable no-footer" cellspacing="1" cellpadding="3" border="0">';
        html += '<tr><th>{$lang['Table Name']}</th><th>{$lang['Attributes']}</th><th>{$lang['Where']}</th><th>{$lang['Link']}</th><th>{$lang['Copy']}</th><th>{$lang['Delete']}</th></tr>';

        for (var tableName in accessTable) {
            if (accessTable.hasOwnProperty(tableName) && accessTable[tableName].length > 0) {
                var tableMd5 = tablesNameMd5[tableName];
                var linkVisit = "{$before_path}/" + tableMd5 + "{$securityWorld}?page=1";
                var whereConditionsString = '';
                if (whereConditions && whereConditions[tableName]) {
                    for (var attr in whereConditions[tableName]) {
                        if (whereConditions[tableName].hasOwnProperty(attr)) {
                            whereConditionsString += '\'' + attr + '\' = \'' + whereConditions[tableName][attr] + '\'; <br>';
                        }
                    }
                }
                html += '<tr>';
                html += '<td><label class="clickable-table-name" data-table-name="' + tableName + '">' + tableName + '</label></td>';
                html += '<td><label>' + accessTable[tableName].join(', ') + '</label></td>';
                html += '<td><label>' + whereConditionsString + '</label></td>';
                html += '<td><label><a href="' + linkVisit + '" target="_blank">' + linkVisit + '</a></label></td>';
                html += '<td><input type="button" class="btn btn-primary btn-block" value="{$lang['Copy']}" onclick="copyToClipboard(\'' + linkVisit + '\')"></td>';
                html += '<td><input type="button" class="btn btn-danger btn-block" value="{$lang['Delete']}" onclick="deleteTableFromVisual(\'' + tableName + '\')"></td>';
                html += '</tr>';
            }
        }

        html += '</table>';
        container.innerHTML = html;

        var clickableTableNames = document.querySelectorAll('.clickable-table-name');
        clickableTableNames.forEach(function(label) {
            label.addEventListener('click', function() {
                var tableName = this.getAttribute('data-table-name');
                selectTable(tableName);
            });
        });
    }

    function selectTable(tableName) {
        var selectElement = document.querySelector('select[name="selected_table"]');
        selectElement.value = tableName;
        updateTableAttributes(selectElement);
    }

    function deleteTableFromVisual(tableName) {
        delete selectedAttributes[tableName];

        updateHiddenField();

        updateVisualTable(selectedAttributes);
    }


    function copyToClipboard(text) {
        var textArea = document.createElement("textarea");
        textArea.value = text;
        document.body.appendChild(textArea);
        textArea.select();
        document.execCommand("Copy");
        textArea.remove();
        alert("{$lang['Link copied to clipboard']}");
    }

    function saveWhereCondition(tableName, attributeName, value) {
        if (!whereConditions[tableName]) {
            whereConditions[tableName] = {};
        }

        if (value.trim() !== '') {
            whereConditions[tableName][attributeName] = value;
        } else {

            delete whereConditions[tableName][attributeName];

            if (Object.keys(whereConditions[tableName]).length === 0) {
                delete whereConditions[tableName];
            }
        }
    }


    window.onload = function() {
        var savedData = JSON.parse(document.querySelector('input[name="available_tables"]').value || '{}');
        var groupName = "{$get['group']}";
        var tableSelect = document.querySelector('select[name="selected_table"]');
        if (tableSelect) {
            updateTableAttributes(tableSelect);
        }
        if (groupName && savedData[groupName]) {
            var groupInfo = savedData[groupName];
            selectedAttributes = groupInfo['access_table'] || {};
            updateVisualTable(selectedAttributes);
            document.querySelector('input[name="group_name"]').value = groupName;
            document.querySelector('input[name="group_name"]').disabled = true;
            document.querySelector('input[name="secret_word"]').value = groupInfo.secret_word || 'no';
            document.querySelector('input[name="access_ip"]').value = groupInfo.access_ip.join(',') || '0.0.0.0';
            var tableSelect = document.querySelector('select[name="selected_table"]');
            if (tableSelect && Object.keys(selectedAttributes).length > 0) {

                updateTableAttributes(tableSelect);
            }
        }else{
            var tableSelect = document.querySelector('select[name="selected_table"]');
            document.querySelector('input[name="group_name"]').value = "{$get['group']}";
            document.querySelector('input[name="secret_word"]').value = 'no';
            document.querySelector('input[name="access_ip"]').value = '0.0.0.0';
            updateTableAttributes(tableSelect);
        }

        setTimeout(function() {
            var successBox = document.querySelector('.successbox');
            if (successBox) {
                successBox.remove();
            }
        }, 5000);
    };







    function checkAllChanged(checkAllElement) {
        var checkboxes = document.querySelectorAll('.checkAllAttributesCheck');
        for (var i = 0; i < checkboxes.length; i++) {
            checkboxes[i].checked = checkAllElement.checked;
        }
        updateSelectedAttributes();
    }

    function checkAttributeChanged(checkboxId) {
        var checkbox = document.getElementById(checkboxId);
        checkbox.checked = !checkbox.checked;
        var attributeName = checkbox.value;

        if (!checkbox.checked) {
            if (whereConditions[currentTable] && whereConditions[currentTable][attributeName]) {
                delete whereConditions[currentTable][attributeName];

                if (Object.keys(whereConditions[currentTable]).length === 0) {
                    delete whereConditions[currentTable];
                }
            }
        }
        updateSelectedAttributes();
    }

    function validateNumberInput(input) {
        const regex = /^[0-9]*$/;
        const currentValue = input.value;
        if (!regex.test(currentValue)) {
            input.value = currentValue.slice(0, -1);
        }
    }
</script>


